<?php

namespace Ardent\Game;

use Ardent\Game\dto\Color;

class MapGenerator
{
    private readonly Noise $noise;

    public function __construct(
        private readonly Renderer $renderer,
    )
    {
        $this->noise = new Noise();
    }

    public function getMap(): array
    {
        $pixels = [];
        for ($x = 0; $x < 280; $x++) {
            for ($y = 0; $y < 140; $y++) {
                $pixels[] = $this->drawPixel($x, $y, $this->noise->generate($x, $y));
            }
        }
        return $pixels;
    }

    private function drawPixel(int $x, int $y, Color $color): string
    {
        return $this->renderer->render('pixel.html.twig', [
            'x' => $x,
            'y' => $y,
            'color' => $color,
        ]);
    }
}