<?php

namespace Ardent\Game;

use Ardent\Game\dto\Color;

class Noise
{
    private readonly PerlinNoise $noise;

    public function __construct(
        float $seed = 0.0,
    )
    {
        $this->noise = new PerlinNoise(4564561234);
    }

    public function generate(int $x, int $y): Color
    {
        $water = new Color(0, 156, 244);
        $sand = new Color(238, 226, 104);
        $grass = new Color(25, 171, 64);
//        $mountain = new Color(169, 94, 64);
        $mountain = new Color(96, 93, 100);
        $snow = new Color(255, 255, 255);

        $rand = $this->noise->random2D($x, $y, 150);
//        $rand = $this->sigmoid($rand);

        if ($rand < 0.0) {
            return $water->lerp($sand, $rand + 1.0);
        } elseif ($rand <= 0.5) {
            return $sand->lerp($grass, $rand * (1.0 / 0.5));
        } elseif ($rand <= 0.99) {
            return $grass->lerp($mountain, ($rand - 0.5) * (1.0 / 0.49));
        } else {
            return $mountain->lerp($snow, ($rand - 0.99) * (1.0 / 0.01));
        }

//        return new Color(
//            red: $rand * 255,
//            green: $rand * 255,
//            blue: $rand * 255,
//        );
    }
}