<?php

namespace Ardent\Game\dto;

class Color
{

    public function __construct(
        public int $red,
        public int $green,
        public int $blue,
        public int $alpha = 255
    )
    {
    }

    public function getCode(): string
    {
//        return "rgba({$this->red}, {$this->green}, {$this->blue}, {$this->alpha})";
        return "rgb({$this->red}, {$this->green}, {$this->blue})";
    }

    public function lerp(Color $color, float $range): Color
    {
        return new Color(
            red: $this->red + ($color->red - $this->red) * $range,
            green: $this->green + ($color->green - $this->green) * $range,
            blue: $this->blue + ($color->blue - $this->blue) * $range,
            alpha: $this->alpha + ($color->alpha - $this->alpha) * $range,
        );
    }
}